/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.community.parkinglot.controller;

import cn.hutool.core.lang.Assert;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.github.xiaoymin.knife4j.annotations.ApiOperationSupport;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import lombok.AllArgsConstructor;
import javax.validation.Valid;

import org.apache.logging.log4j.util.Strings;
import org.springblade.community.agency.entity.Agency;
import org.springblade.community.agency.service.IAgencyService;
import org.springblade.community.residential.entity.Residential;
import org.springblade.community.residential.service.IResidentialService;
import org.springblade.core.mp.support.Condition;
import org.springblade.core.mp.support.Query;
import org.springblade.core.secure.BladeUser;
import org.springblade.core.tool.api.R;
import org.springblade.core.tool.utils.Func;
import org.springblade.system.orgposition.service.IOrgPositionService;
import org.springblade.utils.QueryWrapperUtil;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.bind.annotation.RequestParam;
import com.baomidou.mybatisplus.core.metadata.IPage;
import org.springblade.community.parkinglot.entity.ParkingLot;
import org.springblade.community.parkinglot.vo.ParkingLotVO;
import org.springblade.community.parkinglot.wrapper.ParkingLotWrapper;
import org.springblade.community.parkinglot.service.IParkingLotService;
import org.springblade.core.boot.ctrl.BladeController;

import java.util.Map;

/**
 *  控制器
 *
 * @author BladeX
 * @since 2021-01-04
 */
@RestController
@AllArgsConstructor
@RequestMapping("parkinglot/parkinglot")
@Api(value = "", tags = "安快停车场")
public class ParkingLotController extends BladeController {

	private IParkingLotService parkingLotService;
	private IOrgPositionService orgPositionService;
	private IResidentialService residentialService;
	private IAgencyService agencyService;

	/**
	 * 详情
	 */
	@GetMapping("/detail")
	@ApiOperationSupport(order = 1)
	@ApiOperation(value = "详情", notes = "传入parkingLot")
	public R<ParkingLotVO> detail(ParkingLot parkingLot) {
		ParkingLot detail = parkingLotService.getOne(Condition.getQueryWrapper(parkingLot));
		return R.data(ParkingLotWrapper.build().entityVO(detail));
	}

	/**
	 * 分页
	 */
	@GetMapping("/list")
	@ApiOperationSupport(order = 2)
	@ApiOperation(value = "分页", notes = "传入parkingLot")
	public R<IPage<ParkingLotVO>> list(@RequestParam Map<String,Object> parkingLot, Query query, BladeUser bladeUser) {
		LambdaQueryWrapper<ParkingLot> parkingLotLambdaQueryWrapper = new QueryWrapperUtil<ParkingLot>().getBasicQueryWrapperByMap(ParkingLot::getOrgPosition, parkingLot, new ParkingLot(),bladeUser, orgPositionService);
		IPage<ParkingLot> pages = parkingLotService.page(Condition.getPage(query), parkingLotLambdaQueryWrapper.eq(ParkingLot::getTenantId,bladeUser.getTenantId()));
		return R.data(ParkingLotWrapper.build().pageVO(pages));
	}


	/**
	 * 自定义分页
	 */
	@GetMapping("/page")
	@ApiOperationSupport(order = 3)
	@ApiOperation(value = "分页", notes = "传入parkingLot")
	public R<IPage<ParkingLotVO>> page(ParkingLotVO parkingLot, Query query) {
		IPage<ParkingLotVO> pages = parkingLotService.selectParkingLotPage(Condition.getPage(query), parkingLot);
		return R.data(pages);
	}

	/**
	 * 新增
	 */
	@PostMapping("/save")
	@ApiOperationSupport(order = 4)
	@ApiOperation(value = "新增", notes = "传入parkingLot")
	public R save(@Valid @RequestBody ParkingLot parkingLot) {
		if(Strings.isNotBlank(parkingLot.getResidentialId().toString())){
			Residential residential = residentialService.getById(parkingLot.getResidentialId());
			Assert.notNull(residential,"找不到车场对应的小区");
			parkingLot.setOrgPosition(residential.getOrgPosition());
		}else{
			Assert.notNull(parkingLot.getAgencyId(),"车场所属社区必选");
			Agency agency = agencyService.getById(parkingLot.getAgencyId());
			Assert.notNull(agency,"找不到车场对应的社区");
			parkingLot.setOrgPosition(agency.getOrgPosition());
		}
		return R.status(parkingLotService.save(parkingLot));
	}

	/**
	 * 修改
	 */
	@PostMapping("/update")
	@ApiOperationSupport(order = 5)
	@ApiOperation(value = "修改", notes = "传入parkingLot")
	public R update(@Valid @RequestBody ParkingLot parkingLot) {
		if(Strings.isNotBlank(parkingLot.getResidentialId().toString())){
			Residential residential = residentialService.getById(parkingLot.getResidentialId());
			Assert.notNull(residential,"找不到车场对应的小区");
			parkingLot.setOrgPosition(residential.getOrgPosition());
		}else{
			Assert.notNull(parkingLot.getAgencyId(),"车场所属社区必选");
			Agency agency = agencyService.getById(parkingLot.getAgencyId());
			Assert.notNull(agency,"找不到车场对应的社区");
			parkingLot.setOrgPosition(agency.getOrgPosition());
		}
		return R.status(parkingLotService.updateById(parkingLot));
	}

	/**
	 * 新增或修改
	 */
	@PostMapping("/submit")
	@ApiOperationSupport(order = 6)
	@ApiOperation(value = "新增或修改", notes = "传入parkingLot")
	public R submit(@Valid @RequestBody ParkingLot parkingLot) {
		if(Strings.isNotBlank(parkingLot.getResidentialId().toString())){
			Residential residential = residentialService.getById(parkingLot.getResidentialId());
			Assert.notNull(residential,"找不到车场对应的小区");
			parkingLot.setOrgPosition(residential.getOrgPosition());
		}else{
			Assert.notNull(parkingLot.getAgencyId(),"车场所属社区必选");
			Agency agency = agencyService.getById(parkingLot.getAgencyId());
			Assert.notNull(agency,"找不到车场对应的社区");
			parkingLot.setOrgPosition(agency.getOrgPosition());
		}
		return R.status(parkingLotService.saveOrUpdate(parkingLot));
	}


	/**
	 * 删除
	 */
	@PostMapping("/remove")
	@ApiOperationSupport(order = 7)
	@ApiOperation(value = "逻辑删除", notes = "传入ids")
	public R remove(@ApiParam(value = "主键集合", required = true) @RequestParam String ids) {
		return R.status(parkingLotService.deleteLogic(Func.toLongList(ids)));
	}


}
